/* $Id: wstr.h,v 1.3 2002/07/16 06:36:43 d Exp $ */
/* David Leonard, 2002. Public domain. */

/*
 * A wstr_t is a pointer to a wide-character string.
 */

/* #include "vector.h" */

typedef VECTOR_DECL(wchar_t) *wstr_t;

#define WSTR_START(w)	(&VECTOR_AT(*(w), 0))
#define WSTR_END(w)	(&VECTOR_AT(*(w), VECTOR_LEN(*(w))))
#define	WSTR_ADD(w, c)	VECTOR_APPEND(*(w), c)
#define	WSTR_LEN(w)	VECTOR_LEN(*(w))
#define	WSTR_SIZE(w)	(VECTOR_LEN(*(w)) * sizeof (wchar_t))

struct entity; /* forward decl */

/* prefix with dxml */
#define wstr_new	dxml_wstr_new
#define wstr_free	dxml_wstr_free
#define wstr_str	dxml_wstr_str
#define wstr_addwstr	dxml_wstr_addwstr
#define wstr_addentity	dxml_wstr_addentity
#define entity_wstr	dxml_entity_wstr
#define wstr_eq		dxml_wstr_eq
#define wstr_dup	dxml_wstr_dup
#define wstr_new_wchar	dxml_wstr_new_wchar

wstr_t	wstr_new(void);
void	wstr_free(wstr_t w);
const char *wstr_str(wstr_t w);
void	wstr_addwstr(wstr_t w, wstr_t x);
void	wstr_addentity(wstr_t w, struct entity *e);
struct entity *entity_wstr(wstr_t w);
int	wstr_eq(wstr_t w, wstr_t x);
wstr_t	wstr_dup(wstr_t w);
wstr_t	wstr_new_wchar(wchar_t *, size_t);
