/* $Id: xhash.h,v 1.2 2002/07/16 06:36:43 d Exp $ */
/* David Leonard, 2002. Public domain. */

/* Simple hash table */

/* Hide library-internal names */
#define	xhash_new	dxml_xhash_new
#define	xhash_free	dxml_xhash_free
#define	xhash_lookup	dxml_xhash_lookup
#define	xhash_store	dxml_xhash_store
#define	xhash_iter_new	dxml_xhash_iter_new
#define	xhash_iter_next	dxml_xhash_iter_next
#define	xhash_iter_free	dxml_xhash_iter_free

struct xhash;
struct xhash *xhash_new(void *, void (*)(void *));
void	 xhash_free(struct xhash *);
void 	*xhash_lookup(struct xhash *, const void *, int);
int	 xhash_store(struct xhash *, const void *, int, void *);

/*
 * xhash_new(defaultvalue,freefn)-> create new hash table
 * xhash_free(x)		-> deallocate hash table
 * xhash_lookup(x, key, keylen) -> return data associated with key
 * xhash_store(x, key, keylen, data) -> store data with key; returns 0 on fail
 *	(a copy of the key is made)
 *
 * freefn is called on data when it is overwritten/freed
 */


/* iterator over the contents of a hash table; no particular order */
struct xhash_iter;
struct xhash_iter *xhash_iter_new(struct xhash *);
int	xhash_iter_next(struct xhash_iter *, void *, int *, void **);
void	xhash_iter_free(struct xhash_iter *);
