/* $Id: xml.h,v 1.8 2002/07/21 04:29:39 d Exp $ */
/* David Leonard, 2002. Public domain. */

/* XML document */

struct entity;
typedef struct xml *xml_t;

/* parse an XML document from a UTF8 string */
xml_t	 xml_new_utf8(const char *);
xml_t	 xml_new(const wchar_t *, size_t);
void	 xml_free(xml_t);

/* parse an XML document from an entity */
xml_t	 xml_newe(struct entity *src, 
		 struct entity *(*fetch)(const char *pub, const char *sys),
		 int novalidate);

void	*xml_getuser(xml_t);
void	 xml_setuser(xml_t, void *, void (*)(void *, struct xml *));

int	 xml_puts(xml_t, int (*)(const char *, void *), void *);
int	 xml_puts1(xml_t, int (*)(const char *, void *), void *);
int	 puts_stdio(const char *, void *);

extern const char *xml_last_error;

#define XML_LIBRARY_VERSION	0x0102		/* 1.2 */
#define XML_LIBRARY_DATE	0x200207170
